#!/bin/bash

# knock-R.sh (c) Copyright 2014 Ward Mundy & Associates LLC. All rights reserved.
#                    knock-R.sh is licensed under the GPL2 license
#
#  For a copy of license, visit http://www.gnu.org/licenses/old-licenses/gpl-2.0.html
#  A copy of the license is also available as COPYING for your review.
#
#   For additional information, contact us: http://pbxinaflash.com/about/comment.php

# Unless required by applicable law or agreed to in writing, software distributed under this License 
# is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
# See the License below for the specific language governing permissions and limitations under the License.

# BY USING knock-R.sh SCRIPT, YOU AGREE TO ASSUME ALL RESPONSIBILITY
# FOR USE OF THE PROGRAMS INCLUDED IN THIS INSTALLATION. NO WARRANTIES
# EXPRESS OR IMPLIED INCLUDING MERCHANTABILITY AND FITNESS FOR PARTICULAR
# USE ARE PROVIDED. YOU ASSUME ALL RISKS KNOWN AND UNKNOWN AND AGREE TO
# HOLD WARD MUNDY, WARD MUNDY & ASSOCIATES LLC, NERD VITTLES, AND THE PBX
# IN A FLASH DEVELOPMENT TEAM HARMLESS FROM ANY AND ALL LOSS OR DAMAGE
# WHICH RESULTS FROM YOUR USE OF THIS SOFTWARE. IF ANY OF THESE TERMS
# AND CONDITIONS ARE RULED TO BE UNENFORCEABLE, YOU AGREE TO ACCEPT ONE
# DOLLAR IN U.S. CURRENCY AS COMPENSATORY AND PUNITIVE LIQUIDATED DAMAGES
# FOR ANY AND ALL CLAIMS YOU AND ANY USERS OF THIS SOFTWARE MIGHT HAVE.

if [ -f /etc/debian_version ]; then
    echo "This script requires RedHat/CentOS/Fedora OS."
    exit 1
fi

if [ ! -f /etc/sysconfig/iptables ]; then
    echo "You first must install IPtables."
    exit 2
fi

FWTEST=`grep "INPUT DROP" /etc/sysconfig/iptables`
if [[ ! $FWTEST ]]; then
    echo "IPtables first must be configured to DROP INPUT."
    exit 3
fi

if [ -f /etc/knockd.conf ]; then
    echo "knockd has already been installed."
    exit 4
fi

clear
echo "BY USING knock-R.sh SCRIPT, YOU AGREE TO ASSUME ALL RESPONSIBILITY"
echo "FOR USE OF THE PROGRAMS INCLUDED IN THIS INSTALLATION. NO WARRANTIES"
echo "EXPRESS OR IMPLIED INCLUDING MERCHANTABILITY AND FITNESS FOR PARTICULAR"
echo "USE ARE PROVIDED. YOU ASSUME ALL RISKS KNOWN AND UNKNOWN AND AGREE TO"
echo "HOLD WARD MUNDY, WARD MUNDY & ASSOCIATES LLC, NERD VITTLES, AND THE PBX"
echo "IN A FLASH DEVELOPMENT TEAM HARMLESS FROM ANY AND ALL LOSS OR DAMAGE"
echo "WHICH RESULTS FROM YOUR USE OF THIS SOFTWARE. IF ANY OF THESE TERMS"
echo "AND CONDITIONS ARE RULED TO BE UNENFORCEABLE, YOU AGREE TO ACCEPT ONE"
echo "DOLLAR IN U.S. CURRENCY AS COMPENSATORY AND PUNITIVE LIQUIDATED DAMAGES"
echo "FOR ANY AND ALL CLAIMS YOU AND ANY USERS OF THIS SOFTWARE MIGHT HAVE."
echo " "

echo "If you do not agree with these terms and conditions of use, press Ctrl-C now."
read -p "Otherwise, press Enter to proceed at your own risk..."

clear


cd /root
yum -y install libpcap* curl gawk
publicip=`curl -s -S --user-agent "Mozilla/4.0" http://myip.pbxinaflash.com | awk 'NR==2'`
processor=`uname -i`
centos=${processor:1:3}
### check for 386 and 686
if [ $centos != 686 -a $centos != 386 ] ; then
# 64-bit stuff goes here
 wget http://nerdvittles.dreamhosters.com/pbxinaflash//source/knock/knock-server-0.5-7.el6.nux.x86_64.rpm
else
# 32-bit stuff goes here
 wget http://nerdvittles.dreamhosters.com/pbxinaflash//source/knock/knock-server-0.5-7.el6.nux.i686.rpm
fi
rpm -ivh knock-server*
rm knock-server*
echo "[options]" > /etc/knockd.conf
echo "       logfile = /var/log/knockd.log" >> /etc/knockd.conf
echo "" >> /etc/knockd.conf
echo "[opencloseALL]" >> /etc/knockd.conf
echo "        sequence      = 7:udp,8:udp,9:udp" >> /etc/knockd.conf
echo "        seq_timeout   = 15" >> /etc/knockd.conf
echo "        tcpflags      = syn" >> /etc/knockd.conf
echo "        start_command = /sbin/iptables -A INPUT -s %IP% -j ACCEPT" >> /etc/knockd.conf
echo "        cmd_timeout   = 3600" >> /etc/knockd.conf
echo "        stop_command  = /sbin/iptables -D INPUT -s %IP% -j ACCEPT" >> /etc/knockd.conf
chmod 640 /etc/knockd.conf

# randomize ports here
lowest=6001
highest=9950
knock1=$[ ( $RANDOM % ( $[ $highest - $lowest ] + 1 ) ) + $lowest ]
knock2=$[ ( $RANDOM % ( $[ $highest - $lowest ] + 1 ) ) + $lowest ]
knock3=$[ ( $RANDOM % ( $[ $highest - $lowest ] + 1 ) ) + $lowest ]
sed -i 's|7:udp|'$knock1':tcp|' /etc/knockd.conf
sed -i 's|8:udp|'$knock2':tcp|' /etc/knockd.conf
sed -i 's|9:udp|'$knock3':tcp|' /etc/knockd.conf
chkconfig --level 2345 knockd on
service knockd start

echo "Knock ports for access to $publicip set to TCP: $knock1 $knock2 $knock3" > /root/knock.FAQ
echo "To enable remote access, issue these commands from any remote server:" >> /root/knock.FAQ
echo "nmap -p $knock1 $publicip && nmap -p $knock2 $publicip && nmap -p $knock3 $publicip" >> /root/knock.FAQ
echo "Install iOS PortKnock or Android PortKnocker on smartphone." >> /root/knock.FAQ

echo " "
echo "Install Complete. knockd has been enabled as requested."
echo "Knock ports for access to $publicip set to TCP: $knock1 $knock2 $knock3"
echo "To enable remote access, issue these commands from any remote server:"
echo "nmap -p $knock1 $publicip && nmap -p $knock2 $publicip && nmap -p $knock3 $publicip"
echo "Install iOS PortKnock or Android PortKnocker on smartphone. Read knock.FAQ."
echo " "

# eof

